html {
  font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Oxygen, Ubuntu, Cantarell, 'Open Sans', 'Helvetica Neue', sans-serif;
}

body {
  margin: 0;
  font-size: 0.9em;
}

/* BASE TAGS */
a {
  color: var(--text-active-color);
  text-decoration: none;
  cursor: pointer;
}

a:hover {
  color: lighten(#aaa, 5%);
}

pre[class*="language-"] {
  background-color: var(--pre-bg) !important;
  color: var(--pre-color) !important;
}

pre code {
  text-shadow: 0 1px var(--contrast-color);
}

input[type="file"] {
  display: none;
}

/* GENERAL STYLES */
.mini {
  font-size: 0.65em;
}
.small {
  font-size: 0.85em;
}
.medium {
  font-size: 1em;
}
.big {
  font-size: 1.2em;
}
.large {
  font-size: 1.4em;
}

.fb {
  font-weight: bold;
}
.fi {
  font-style: italic;
}
.code {
  font-family: monospace;
}

.i-mini {
  font-size: 0.65em !important;
}
.i-small {
  font-size: 0.85em !important;
}
.i-medium {
  font-size: 1em !important;
}
.i-big {
  font-size: 1.2em !important;
}

.left {
  text-align: left;
}
.center {
  text-align: center;
}
.right {
  text-align: right;
}
.justify {
  text-align: justify;
}

.light {
  color: var(--grey-lighter);
}

.full-width {
  width: 100%;
}
.full-height {
  height: 100%;
}

.no-radius {
  border-radius: 0 !important;
}
.radius-top {
  border-radius: var(--border-radius) var(--border-radius) 0 0 !important;
}
.radius-right {
  border-radius: 0 var(--border-radius) var(--border-radius) 0 !important;
}
.radius-bottom {
  border-radius: 0 0 var(--border-radius) var(--border-radius) !important;
}
.radius-left {
  border-radius: var(--border-radius) 0 0 var(--border-radius) !important;
}

.border {
  border: 1px solid var(--body-color);
}
.border-top {
  border-top: 1px solid var(--body-color);
}
.border-right {
  border-right: 1px solid var(--body-color);
}
.border-bottom {
  border-bottom: 1px solid var(--body-color);
}
.border-left {
  border-left: 1px solid var(--body-color);
}

.no-border {
  border: none !important;
}
.no-border-top {
  border-top: none !important;
}
.no-border-right {
  border-right: none !important;
}
.no-border-bottom {
  border-bottom: none !important;
}
.no-border-left {
  border-left: none !important;
}

.p-abs {
  position: absolute;
}
.p-rel {
  position: relative;
}
.p-fix {
  position: fixed;
}

.clickable {
  cursor: pointer;
}

/* FLEX */
.flex-inline {
  display: flex;
  flex-direction: row;
  align-items: center;
}

.flex-column {
  display: flex;
  flex-direction: column;
}

.flex-grow {
  flex-grow: 1;
}

.flex-wrap {
  flex-wrap: wrap;
}

.align-items-start, .align-top {
  align-items: flex-start;
}
.align-items-end, .align-bottom {
  align-items: flex-end;
}
.align-items-center, .align-middle {
  align-items: center;
}
.align-items-baseline, .align-baseline {
  align-items: baseline;
}

.justify-content-start {
  justify-content: flex-start;
}
.justify-content-center {
  justify-content: center;
}
.justify-content-between {
  justify-content: space-between;
}
.justify-content-around {
  justify-content: space-around;
}
.justify-content-evenly {
  justify-content: space-evenly;
}
.justify-content-end {
  justify-content: flex-end;
}

/* MARGINS & PADDING */
.no-margin {
  margin: 0;
}

.mt-half { margin-top: 0.5rem; }
.mt-1 { margin-top: 1rem; }
.mt-2 { margin-top: 2rem; }
.mt-3 { margin-top: 3rem; }
.mr-half { margin-right: 0.5rem; }
.mr-1 { margin-right: 1rem; }
.mr-2 { margin-right: 2rem; }
.mr-3 { margin-right: 3rem; }
.mb-half { margin-bottom: 0.5rem; }
.mb-1 { margin-bottom: 1rem; }
.mb-2 { margin-bottom: 2rem; }
.mb-3 { margin-bottom: 3rem; }
.ml-half { margin-left: 0.5rem; }
.ml-1 { margin-left: 1rem; }
.ml-2 { margin-left: 2rem; }
.ml-3 { margin-left: 3rem; }
.mx-half { margin-left: 0.5rem; margin-right: 0.5rem; }
.mx-1 { margin-left: 1rem; margin-right: 1rem; }
.mx-2 { margin-left: 2rem; margin-right: 2rem; }
.mx-3 { margin-left: 3rem; margin-right: 3rem; }
.my-half { margin-top: 0.5rem; margin-bottom: 0.5rem; }
.my-1 { margin-top: 1rem; margin-bottom: 1rem; }
.my-2 { margin-top: 2rem; margin-bottom: 2rem; }
.my-3 { margin-top: 3rem; margin-bottom: 3rem; }

.pt-half { padding-top: 0.5rem; }
.pt-1 { padding-top: 1rem; }
.pt-2 { padding-top: 2rem; }
.pt-3 { padding-top: 3rem; }
.pr-half { padding-right: 0.5rem; }
.pr-1 { padding-right: 1rem; }
.pr-2 { padding-right: 2rem; }
.pr-3 { padding-right: 3rem; }
.pb-half { padding-bottom: 0.5rem; }
.pb-1 { padding-bottom: 1rem; }
.pb-2 { padding-bottom: 2rem; }
.pb-3 { padding-bottom: 3rem; }
.pl-half { padding-left: 0.5rem; }
.pl-1 { padding-left: 1rem; }
.pl-2 { padding-left: 2rem; }
.pl-3 { padding-left: 3rem; }
.px-half { padding-left: 0.5rem; padding-right: 0.5rem; }
.px-1 { padding-left: 1rem; padding-right: 1rem; }
.px-2 { padding-left: 2rem; padding-right: 2rem; }
.px-3 { padding-left: 3rem; padding-right: 3rem; }
.py-half { padding-top: 0.5rem; padding-bottom: 0.5rem; }
.py-1 { padding-top: 1rem; padding-bottom: 1rem; }
.py-2 { padding-top: 2rem; padding-bottom: 2rem; }
.py-3 { padding-top: 3rem; padding-bottom: 3rem; }

/* ELEMENTS */
/* ------ BUTTONS */
.btn {
  display: flex;
  cursor: pointer;
  background-color: var(--btn-bg);
  border: 2px solid var(--btn-border);
  color: var(--btn-color);
  padding: 5px;
  border-radius: var(--border-radius);
  justify-content: center;
  align-items: center;
}
.btn:hover, .btn-active {
  background-color: var(--btn-hover-bg);
  border-color: var(--btn-hover-border);
  color: var(--btn-hover-color);
}
.btn:active {
  background-color: var(--btn-active-bg);
  border-color: var(--btn-active-border);
  color: var(--btn-active-color);
}
.btn:focus {
  outline: none;
}
.btn:disabled {
  background-color: var(--btn-disabled-bg);
  border-color: var(--btn-disabled-border);
  color: var(--btn-disabled-color);
  cursor: default;
}

.btn-big {
  height: 34px;
  font-size: 1.1em;
}

.btn-square-mini {
  width: 12px;
  height: 12px;
  font-size: 0.8em;
}
.btn-square-small {
  width: 16px;
  height: 16px;
}
.btn-square-medium {
  width: 22px;
  height: 22px;
  font-size: 1.2em;
  padding: 3px;
}
.btn-square-large {
  width: 26px;
  height: 26px;
  font-size: 1.2em;
  padding: 3px;
}
.btn-square-full {
  width: 100%;
  height: 100%;
  padding: 3px;
}

/* ------ INPUTS */
.input {
  background-color: var(--input-bg);
  border: 2px solid var(--input-border);
  color: var(--input-color);
  padding: 0px 3px;
  border-radius: var(--border-radius);
  height: 18px;
}

.input:focus {
  outline-color: var(--text-active-color);
}

/* ------ LISTS */
.list {
  list-style: none;
  margin: 0;
}

.list.list-selectable .list-item {
  color: var(--list-item-color);
  cursor: pointer;
}

.list.list-selectable .list-item:hover {
  color: var(--list-item-hover-color);
}

/* ------ SWITCHES */
.switch {
  position: relative;
  display: inline-block;
}

.switch-input {
  display: none;
}

.switch-label {
  display: block;
  width: var(--switch-width);
  height: var(--switch-height);
  text-indent: -150%;
  clip: rect(0 0 0 0);
  color: transparent;
  user-select: none;
  margin-bottom: 0;
}

.switch-label:before, .switch-label:after {
  content: '';
  display: block;
  position: absolute;
  cursor: pointer;
}

.switch-label:before {
  width: 100%;
  height: 100%;
  background-color: var(--switch-bg-off);
  border-radius: 9999em;
  transition: background-color 0.25s ease;
}

.switch-label:after {
  top: 0;
  left: 0;
  width: var(--switch-knob-width);
  height: var(--switch-knob-height);
  border-radius: 50%;
  background-color: var(--switch-bg-knob);
  box-shadow: 0 0 2px rgba(0, 0, 0, 0.45);
  transition: left 0.25s ease;
}

.switch-input:checked + .switch-label:before {
  background-color: var(--switch-bg-on);
}

.switch-input:checked + .switch-label:after {
  left: calc(var(--switch-knob-width) * 2);
}

/* ------ MISC */
.overlay-dark {
  width: 100%;
  height: 100%;
  background-color: rgba(0, 0, 0, 0.15);
  position: absolute;
  top: 0;
  left: 0;
  pointer-events: none;
  display: flex;
  justify-content: center;
  align-items: center;
  font-size: 3em;
}

/* ------ NOTIFICATIONS */
.notifications,
.vue-notification-group {
  position: fixed;
  z-index: 100;
  right: var(--gutter) !important;
  bottom: calc(var(--footer-height) + 1em + var(--gutter)) !important;
}

.vue-notification {
  padding: 10px;
  margin: 0 5px 5px;
  font-size: 12px;
  color: #ffffff;
  background: #44A4FC;
  border-left: 5px solid #187FE7;

  &.warn {
    background: #ffb648;
    border-left-color: #f48a06;
  }

  &.error {
    background: #E54D42;
    border-left-color: #B82E24;
  }

  &.success {
    background: #68CD86;
    border-left-color: #42A85F;
  }
}

.vue-notification .notification-title {
  font-weight: bold;
}

.notifications-fade-right-enter-active,
.notifications-fade-right-leave-active,
.notifications-fade-right-move {
    transition: all 0.5s;
}
.notifications-fade-right-enter,
.notifications-fade-right-leave-to {
    opacity: 0;
    transform: translateX(500px) scale(0.2);
}
